;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  emacs-lazy 2.0 (emacs-lisp for lazy)
;;  Copyright (C) 2002.7 Yusuke Kaneki <kaneki@ueda.info.waseda.ac.jp> 
;;
;;  last modified 2002.8.19

;;  
;;    Esc-s              Xshell$B%b!<%I(B
;;    
;;    Ctrl-f             $B%+!<%=%k$N>l=j$NJ8;zNs$r%U%!%$%kL>$H$7$F(B
;;                       $B?7$7$$%&%$%s%I%&$K$=$N%U%!%$%k$rI=<($9$k!#(B
;;    Ctrl-c Ctrl-f      $B$"$?$i$7$/(Bemacs$B$r3+$$$FI=<($9$k!#(B
;;
;;    Ctrl-c Ctrl-g      grep $B$N=q<0$r8+$F!"$=$N%U%!%$%k$r(B
;;                       $B?7$7$$%&%$%s%I%&$KI=<($7!"$=$N9T$r8!:w$9$k!#(B
;;
;;    $B>e5-(B 3$B$D$O(B Xshell$B%b!<%IFb$G$N$_$N%-!<%P%$%s%I!#(B
;;
;;
;;    Ctrl-c Ctrl-m      make
;;
;;    Ctrl-[$B"-(B $B",(B]       $BJ,3d$5$l$?%&%$%s%I%&$N0\F0!#(B
;;    Ctrl-[l p]         $B%7%'%k%b!<%I$G$O!"$3$N%-!<%P%$%s%I$K(B
;;                       $B%3%^%s%IMzNr$,%P%$%s%I$5$l$F$$$k$N$G!"(B
;;                       Ctrl-i,j
;;
;;    Ctrl-[$B"+(B $B"*(B]       $B%P%C%U%!!<$r0\F0$9$k!#(B 
;;    Ctrl-[n j] 
;;
;;    Ctrl-w Ctrl-b      $B%P%C%U%!!<0\F0%b!<%I(B
;;                       "select buffer or window"
;;                       $B$H2<$K=P$F$$$k;~$K!"(BCtrl-w $B$G:#I=<($7$F$$$k(B
;;                       $B%&%$%s%I%&$N:o=|!#(BCtrl-b $B$G%P%C%U%!!<$N:o=|!#(B
;;                       $BMF<O$J$/:o=|$9$k$N$G$*5$$r$D$1$F!#(B
;;
;;    Shift-[$B"-"+","*(B]   $B%7%U%H$r2!$7$J$,$iLp0uNN0h$r@qBr(B
;;                       Ctrl-C $B$G%3%T!<(B 
;;                       Ctrl-v $B$G%+%C%H(B
;;                       Backspace $B$G@qBrNN0h$N:o=|(B 
;;
;;    wheel-[up down]    $B%[%$!<%k%^%&%9$G%9%/%m!<%k$,=PMh$k!#(B
;;                       $B%7%U%H$r2!$7$J$,$i$GG\B.$G%9%/%m!<%k$9$k!#(B


;;; make
;;;

(global-set-key "\C-c\C-m" 'make-command)
(defun make-command ()
  (interactive)
  (shell-command "make"))

;;; Esc-s shell
;;;

(global-set-key "\es" 'xshell-mode)

;;; move buffer or window
;;; 

(global-set-key "\C-n" 'c-left)
(global-set-key "\C-j" 'c-right)
(global-set-key "\C-l" 'c-down)
(global-set-key "\C-p" 'c-up)
(global-set-key [(control right)] 'c-right)
(global-set-key [(control left)] 'c-left)
(global-set-key [(control up)] 'c-up)
(global-set-key [(control down)] 'c-down)

(defun c-right ()
  (interactive)
  (change-buffer 'C-right))

(defun c-left ()
  (interactive)
  (change-buffer 'C-left))

(defun c-up ()
  (interactive)
  (change-buffer 'C-up))

(defun c-down ()
  (interactive)
  (change-buffer 'C-down))

(defun change-buffer (key)
  (let (plus-buffer-list x)
    (setq plus-buffer-list (buffer-list))
    (if (catch 'found
	  (while t
	    (if (symbolp key)
		(cond ((string= "C-left" key)
		       (setq x nil)
		       (while (cadr plus-buffer-list)
			 (setq x (append x (cons (car plus-buffer-list) nil)))
			 (setq plus-buffer-list (cdr plus-buffer-list)))
		       (setq plus-buffer-list (cons (car plus-buffer-list) x))
		       (switch-to-buffer (car plus-buffer-list)))
		      
		      ((string= "C-right" key)
		       (switch-to-buffer (cadr plus-buffer-list))
		       (setq plus-buffer-list
			     (append (cdr plus-buffer-list)
				     (cons (car plus-buffer-list) nil))))
		      
		      ((string= "C-down" key)
		       (select-window (next-window)))
		      
		      ((string= "C-up" key)
		       (select-window (previous-window)))

		      (t (throw 'found t)))

	      (if (integerp key)
		  (cond ((= 10 key)
			 (switch-to-buffer (cadr plus-buffer-list))
			 (setq plus-buffer-list
			       (append (cdr plus-buffer-list)
				       (cons (car plus-buffer-list) nil))))

			((= 14 key)
			 (setq x nil)
			 (while (cadr plus-buffer-list)
			   (setq x (append x (cons (car plus-buffer-list) nil)))
			   (setq plus-buffer-list (cdr plus-buffer-list)))
			 (setq plus-buffer-list (cons (car plus-buffer-list) x))
			 (switch-to-buffer (car plus-buffer-list)))

			((= 16 key)
			 (select-window (previous-window)))

			((= 12 key)
			 (select-window (next-window)))

			((= 2 key)
			 (if (or (string= (buffer-name) "*scratch*")
			       (string= (buffer-name) "*Messages*")
			       (string= (buffer-name) " *Rail*")
			       (string= (buffer-name) "*Minibuf-0*"))
			   t
			   (kill-buffer (current-buffer))))

			((= 23 key)
			 (delete-window))

			(t (throw 'found t)))
		(throw 'found t)))
	    (setq key (read-event "seletct buffer or window"))))
	t
      t)))


;;; cut and paste
;;;

(global-set-key [(shift left)] 's-left)
(global-set-key [(shift right)] 's-right)
(global-set-key [(shift down)] 's-down)
(global-set-key [(shift up)] 's-up)

(defun s-left ()
  (interactive)
  (copy-cut-region 'S-left))

(defun s-right ()
  (interactive)
  (copy-cut-region 'S-right))

(defun s-down ()
  (interactive)
  (copy-cut-region 'S-down))

(defun s-up ()
  (interactive)
  (copy-cut-region 'S-up))

(defun copy-cut-region (key)
  (let (mark-beg mark-end overlay0 copy-region-face x)
    (make-face copy-region-face)
    (set-face-foreground copy-region-face "wheat")
    (set-face-background copy-region-face "blue")
    (setq overlay0 (make-overlay (point) (point)))
    (overlay-put overlay0 'face copy-region-face)
    (setq mark-beg (point))
    (set-mark (point))
    (if (catch 'found
	  (while (not (eobp))
	    (if (symbolp key)
		(cond ((string= "S-left" key)
		       (delete-overlay overlay0)
		       (backward-char 1)
		       (move-overlay overlay0 (point) mark-beg))
		      
		      ((string= "S-right" key)
		       (delete-overlay overlay0)
		       (if (< (point) (- (point-max) 1))
			   (forward-char 1)
			 (goto-char (- (point-max) 1)))
		       (move-overlay overlay0 (point) mark-beg))
		      
		      ((string= "S-down" key)
		       (delete-overlay overlay0)		
		       (setq x (point))
		       (beginning-of-line)
		       (setq x (- x (point)))
		       (forward-line 1)
		       (if (< (+ (point) x) (point-max))
			   (forward-char x)
			 (goto-char (- (point-max) 1)))
		       (move-overlay overlay0 (point) mark-beg))
		      
		      ((string= "S-up" key)
		       (delete-overlay overlay0)		  
		       (setq x (point))
		       (beginning-of-line)
		       (setq x (- x (point)))
		       (forward-line -1)
		       (forward-char x)
		       (move-overlay overlay0 (point) mark-beg))

		      ((string= "backspace" key)
		       (if (= (point-max) (point))
			   (delete-region mark-beg (- (point) 1))
			 (delete-region mark-beg (point))))

		      (t (throw 'found t)))

	      (if (integerp key)
		  (cond ((= 3 key)
			 (delete-overlay overlay0)
			 (if (= mark-beg (point))
			     (throw 'found t)	       
			   (progn (message "copy" t)
				  (copy-region-as-kill mark-beg (point))
				  (setq key nil)
				  (throw 'found t))))
			
			((= 24 key)
			 (delete-overlay overlay0)
			 (if (= mark-beg (point))
			     (throw 'found t)
			   (progn (message "cut" t)
				  (kill-region  mark-beg (point))
				  (setq key nil)
				  (throw 'found t))))
			(t (throw 'found t)))
		(throw 'found t)))
	    (setq key (read-event "copy or cut region"))))
	(delete-overlay overlay0)
      (delete-overlay overlay0))
    (cond ((char-or-string-p key)
	   (insert (char-to-string key)))
	  ((symbolp key)
	   (cond ((string= "left" key)
		  (backward-char 1))
		      
		 ((string= "right" key)		   
		  (forward-char 1))
		      
		 ((string= "down" key)		
		  (setq x (point))
		  (beginning-of-line)
		  (setq x (- x (point)))
		  (forward-line 1)
		  (forward-char x))

		 ((string= "up" key)		  
		  (setq x (point))
		  (beginning-of-line)
		  (setq x (- x (point)))
		  (forward-line -1)
		  (forward-char x)))))))

;;; wheel mouse
;;;

(defun up-one () (interactive) (scroll-up 3))
(defun down-one () (interactive) (scroll-down 3))
(global-set-key [mouse-4] 'down-one)
(global-set-key [mouse-5] 'up-one)
(defun up-one2 () (interactive) (scroll-up 7))
(defun down-one2 () (interactive) (scroll-down 7))
(global-set-key [S-mouse-4] 'down-one2)
(global-set-key [S-mouse-5] 'up-one2)


;;; Xshell
;;;

(define-derived-mode xshell-mode
  shell "Xshell-mode"
  ""
  (set-syntax-table xshell-mode-syntax-table)
  (setq case-fold-search nil)
  (make-local-variable 'font-lock-defaults)
  (setq font-lock-defaults xshell-font-lock-defaults)
  (define-key xshell-mode-map "\C-f" 'xshell-open-file)
  (define-key xshell-mode-map "\C-c\C-g" 'xshell-grep)
  (define-key xshell-mode-map "\C-c\C-f" 'xshell-open-file-other-frame)
)

(defun xshell-open-file-other-frame ()
  (interactive)
  (let ()
    (find-file-other-frame (thing-at-point 'word))))

(defun xshell-open-file ()
  (interactive)
  (let ()
    (find-file-other-window (thing-at-point 'word))))

(defun xshell-grep ()
  (interactive)
  (let (beg-line end-line file text target-beg target-end)
    (save-excursion
      (end-of-line)
      (setq end-line (point))
      (beginning-of-line)
      (setq beg-line)
      (setq file (thing-at-point 'word))
      (search-forward ":" end-line 0)
      (re-search-forward "[^\\ ]" end-line 0)
      (setq target-beg (- (point) 1))
      (end-of-line)
      (re-search-backward "[^\\ ]" beg-line 0)
      (setq target-end (+ (point) 1))
      (setq text (buffer-substring target-beg target-end))
      (find-file-other-window file)
      (goto-char (point-min))
      (search-forward text nil 0)
      (beginning-of-line))))

(defvar xshell-font-lock-defaults 
  (list 'xshell-font-lock-keywords
	nil
	nil
	nil
	'beginning-of-line
	))

(progn
  (setq xshell-mode-syntax-table (make-syntax-table))
  (modify-syntax-entry ?/ "." xshell-mode-syntax-table)
  (modify-syntax-entry ?\\ "\\" xshell-mode-syntax-table)
  
  (modify-syntax-entry ?~ "w" xshell-mode-syntax-table)
  (modify-syntax-entry ?. "w" xshell-mode-syntax-table)
  (modify-syntax-entry ?_ "w" xshell-mode-syntax-table)
  (modify-syntax-entry ?- "w" xshell-mode-syntax-table)
  
  (modify-syntax-entry ?\" "\"" xshell-mode-syntax-table)
)


(defconst xshell-font-lock-keywords
  (list
   '("^\\[.*\\]\\$"
     0 font-lock-warning-face)
   '("[-_0-9a-zA-Z.~]*/"
     0 font-lock-keyword-face)
   '("[ ]core[-_0-9a-zA-Z.]*\\|\\([ ]\\|^\\)\\#[-_0-9a-zA-Z.]*\\#"
     0 font-lock-comment-face)
   )) 
